#!/usr/bin/perl

$PGSHOME = `pwd`;
chomp $PGSHOME;
$prefix     = $PGSHOME . "/bin/tmp";
$out_prefix = $PGSHOME . "/bin/linux"; 
@env_files = ( "pgs-dev-env-linux.csh.tmp", "pgs-env-linux.csh.tmp", "pgs-dev-env-linux.ksh.tmp", "pgs-env-linux.ksh.tmp" );


foreach $file (@env_files)
{
   open(ENVFILE, "$prefix/$file") || die "Can't open file: $prefix/$file";

   $outfile = $file;
   $outfile =~ s/(.*?)-linux(.*?)\.tmp/$1$2/;

   open(OUTFILE, ">$out_prefix/$outfile") || die "Can't open file: /tmp/$outfile";

   while(<ENVFILE>)
   {
      if($_ =~ /__PGSHOME__/)
      {
         if($file =~ /^.*?\.csh\.tmp$/)
         {
            print(OUTFILE "setenv PGSHOME $PGSHOME\n");
         }
         
         if( $file =~ /^.*?\.ksh\.tmp$/)
         {
               print(OUTFILE "PGSHOME=$PGSHOME\n");
         }
      }
      else
      {
         print(OUTFILE "$_");
      }
   }

   close(OUTFILE);
   close(ENVFILE);
}

printf(STDOUT "###############################################################\n");
printf(STDOUT "##                      DONE                                   \n");
printf(STDOUT "##  Remember to source  $PGSHOME/bin/linux/pgs-dev-env.csh     \n");
printf(STDOUT "##    or $PGSHOME/bin/linux/pgs-dev-env.ksh                    \n");
printf(STDOUT "##    to set the environmental variables correctly             \n");
printf(STDOUT "###############################################################\n");

