/*-------------------------------------------------------------------------*/
/*                                                                         */
/*  COPYRIGHT[copyright mark] 1996, Hughes Aircraft Company, its vendors,  */
/*  and suppliers.  ALL RIGHTS RESERVED.                                   */
/*                                                                         */
/*-------------------------------------------------------------------------*/
/*******************************************************************************
BEGIN_FILE_PROLOG:

FILENAME:
  PGS_EPH_bindFORTRAN.c

DESCRIPTION:
  This file contains FORTRAN bindings for the SDP Toolkit Spacecraft Ephemeris
  and Attitude Data Access (EPH) tools. 

AUTHOR:
  Guru Tej S. Khalsa / Applied Research Corporation

HISTORY:
  02-Jun-1995  GTSK          Initial version
  28-Sep-1998  Abe Taaheri   changed binding for pgs_eph_getephmet 
                             (NCR ECSed17947)

END_FILE_PROLOG:
*******************************************************************************/

#include <cfortran.h>
#include <PGS_EPH.h>

/*********************
 * cfortran.h MACROS *
 *********************/

/* The following macros are expanded by cfortran.h to C functions which allow
   FORTRAN users to access the SDP Toolkit relatively painlessly. */

/* PGS_EPH_EphemAttit() */

FCALLSCFUN12(INT, PGS_EPH_EphemAttit, PGS_EPH_EPHEMATTIT, pgs_eph_ephemattit, \
             INT, INT, STRING, DOUBLEV, INT, INT, PVOID, DOUBLEVV, DOUBLEVV, \
	     DOUBLEVV, DOUBLEVV, DOUBLEVV)

/* PGS_EPH_GetEphMet() */

#define pgs_eph_getephmetc_STRV_A8 NUM_ELEM_ARG(3)
#define pgs_eph_getephmetc_STRV_A9 NUM_ELEM_ARG(3)

FCALLSCFUN10(INT, PGS_EPH_GetEphMetAux, PGS_EPH_GETEPHMETC, \
	     pgs_eph_getephmetc, \
	     INT, INT, INT, STRING, DOUBLEV, PINT, INTV, PSTRINGV, PSTRINGV, \
	     DOUBLEV)

/* PGS_EPH_interpolateAttitude() */

FCALLSCFUN10(INT, PGS_EPH_interpolateAttitude, PGS_EPH_INTERPOLATEATTITUDE, \
 	     pgs_eph_interpolateattitude, DOUBLE, DOUBLEV, DOUBLEV, DOUBLE, \
 	     DOUBLEV, DOUBLEV, INTV, DOUBLE, DOUBLEV, DOUBLEV)

/* PGS_EPH_interpolatePosVel() */

FCALLSCFUN9(INT, PGS_EPH_interpolatePosVel, PGS_EPH_INTERPOLATEPOSVEL, \
	    pgs_eph_interpolateposvel, DOUBLE, DOUBLEV, DOUBLEV, DOUBLE, \
	    DOUBLEV, DOUBLEV, DOUBLE, DOUBLEV, DOUBLEV)
